<template lang="pug">

div.body.public(
  :class="loading ? 'body_loading' : ''")

  link(href='/jivosite/jivosite.css', rel='stylesheet')
  script(src='/jivosite/jivosite.js', type='text/javascript')


  .dot-elastic(v-if="loading")

  .el-menu.main-menu(
    :style="`background-color:${menuBG}`")

    nav.menu-item__wrapper

      .el-menu-item.logo(
        index='0'
        style="order:4")

        .menu__logo(
          v-if="$route.path === '/'")
          img(
          src="/img/logo.png"
          alt="АО Шувалово")

        nuxt-link.menu__logo(
          to="/"
          v-if="$route.path !== '/'")

          img(
            src="/img/logo.png"
            alt="АО Шувалово")


      .el-menu-item(
        index='1'
        :style="styleNavLinks(false, 'main')"
        :class="menuItemClass({path:'/'})")
        nuxt-link(to="/") Главная
        .el-menu-item__underscore(
          v-if="$route.path !== '/'")

      .el-menu-item(
        v-for="item in navLinks"
        :key="`link-${item.index}`"
        :index='String(item.index)'
        :style="styleNavLinks(item)"
        :class="menuItemClass(item)")
        nuxt-link(:to="item.path") {{ item.name }}
        .el-menu-item__underscore(:style="styleNavLinks(false, false, 'underscore')")

      .el-menu-item(
        :style="styleNavLinks({index: '100'})"
        :class="menuItemClass({path:'/user'})")

        app-profile-panel(
          :buttonColor="`color:${$route.path === '/' && !mobileMenuView ? $store.state.menuColor : ''}`"
          @user-exit="userExit")

  app-mobile-menu(
    :navLinks="navLinks"
    @user-exit="userExit")

  .main-wrapper(
    :style="$route.path === '/' ? 'padding-bottom: 0' : ''")
    nuxt

  .main-footer(
    :class="classesFooter()")
    .main-footer__wrapper
      p.copy &copy; 2011-{{new Date().getFullYear()}} &laquo;АО Шувалово&raquo;
      .social-links
        a.social-links__item(
          href="/"
          target="_blank"
          aria-label="Ссылка на группу в ВКонтакте")
          font-awesome-icon(:icon="['fab','vk']")

        a.social-links__item(
          href="/"
          target="_blank"
          aria-label="Ссылка на группу в ВКонтакте")
          font-awesome-icon(:icon="['fab','odnoklassniki']")

        a.social-links__item(
          href="/"
          target="_blank"
          aria-label="Ссылка на группу в ВКонтакте")
          font-awesome-icon(:icon="['fab','instagram']")

        a.social-links__item(
          href="/"
          target="_blank"
          aria-label="Ссылка на группу в ВКонтакте")
          font-awesome-icon(:icon="['fab','facebook-f']")

  - var ENV = process.env.NODE_ENV
  if ENV === 'production'

  <!-- BEGIN JIVOSITE CODE {literal}-->
  script(type='text/javascript').
    (function(){ var widget_id = 'nqV8TjY6uU';var d=document;var w=window;function l(){
      var s = document.createElement('script'); s.type = 'text/javascript'; s.async = true;
      s.src = '//code.jivosite.com/script/widget/'+widget_id
      ; var ss = document.getElementsByTagName('script')[0]; ss.parentNode.insertBefore(s, ss);}
      if(d.readyState=='complete'){l();}else{if(w.attachEvent){w.attachEvent('onload',l);}
      else{w.addEventListener('load',l,false);}}})();
  <!-- {/literal} END JIVOSITE CODE-->


</template>
<script>
import { mapGetters, mapMutations } from 'vuex';
import * as Cookies from 'js-cookie';

import ProfilePanel from '../components/public/ProfilePanel';
import MobileMenu from '../components/public/MobileMenu';

export default {
  components: {
    'app-profile-panel': ProfilePanel,
    'app-mobile-menu': MobileMenu
  },
  data() {
    return {
      navLinks: [
        {
          index: 2,
          name: 'О компании',
          path: '/about'
        },
        {
          index: 3,
          name: 'Каталог',
          path: '/catalog'
        },
        {
          index: 4,
          name: 'Блог',
          path: '/news'
        },
        {
          index: 5,
          name: 'Cотрудничество',
          path: '/cooperation'
        },
        {
          index: 6,
          name: 'Контакты',
          path: '/contacts'
        }
      ],
      mobileMenuView: false,
      menuBG: 'rgba(255,255,255,0)',
      pageLoad: false
    };
  },
  computed: {
    ...mapGetters({
      loading: 'LOADING'
    })
  },
  watch: {
    '$route.path'(value) {
      this.SET_LOADING(true);
    }
  },
  created() {
    if (Cookies.get('__a_t')) {
      this.$axios
        .post('/api/v1/authFromToken', {
          access_token: Cookies.get('__a_t') || '',
          refresh_token: Cookies.get('__r_t') || ''
        })
        .then(data => {
          if (data.status === 200 && data.data.role === 'admin') {
            this.$store.commit('userAuth', true);
            this.$store.commit('adminAuth', true);
            this.$store.commit('user', data.data);
          } else if (data.status === 200) {
            this.$store.commit('userAuth', true);
            this.$store.commit('user', data.data);
          } else {
            this.removeCoockie();
          }
        })
        .catch(() => {
          this.removeCoockie();
        });
    } else {
      this.removeCoockie();
    }
  },
  mounted() {
    this.$axios.setHeader('Cookies', document.cookie);
    this.$nextTick(() => {
      window.addEventListener('resize', this.getWindowWidth);
    });
    this.getWindowWidth();
    this.checkCoockie();
  },
  methods: {
    ...mapMutations(['SET_LOADING']),
    classesFooter() {
      return {
        'footer-home': this.$route.path === '/',
        'footer-inner': this.$route.path !== '/'
      };
    },
    styleNavLinks(item, linkName, type) {
      let style = {};
      if (this.$route.path === '/') {
        style.color = this.$store.state.menuColor;
      }
      if (item) {
        style.order = Number(item.index) - 1;
      }
      if (linkName === 'main' && this.$route.path === '/') {
        style.color = '#fff';
      }
      if (type === 'underscore' && this.$route.path === '/') {
        style.backgroundColor = this.$store.state.menuColor;
      }
      if (type === 'burger' && this.mobileMenuView) {
        style.color = '#000';
        style.opacity = '0.6';
      }
      return style;
    },
    menuItemClass(item) {
      return {
        'active-item':
          this.$route.path.includes(item.path) && item.path !== '/',
        'active-item_main-page': item.path === '/' && this.$route.path === '/'
      };
    },
    checkCoockie() {
      if (
        typeof Cookies.get('__r_t') !== 'undefined' &&
        atob(Cookies.get('__r_t'))
      ) {
        let coockeisExpires = atob(Cookies.get('__r_t')).split('|')[1];
        if (coockeisExpires < this.$moment().valueOf()) {
          this.removeCoockie();
        }
      } else {
        this.removeCoockie();
      }
    },
    removeCoockie() {
      this.$store.commit('userAuth', false);
      this.$store.commit('adminAuth', false);
      this.$store.commit('user', null);
      Cookies.remove('__a_t');
      Cookies.remove('__r_t');
      if (this.$route.path === '/user-profile') {
        this.$router.push('login');
      }
    },
    userExit() {
      this.mobileMenuView = false;
      this.profilePopover = !this.profilePopover;
      this.$store.commit('userAuth', false);
      this.$store.commit('adminAuth', false);
      this.$store.commit('user', null);
      Cookies.remove('__a_t');
      if (this.$route.path === '/user-profile') {
        this.$router.push('login');
      }
      this.$message.success('Вы успешно разлогинились!');
    },
    getWindowWidth() {
      if (
        this.$currentViewport.label === 'desktop' ||
        this.$currentViewport.label === 'desktop-large' ||
        this.$currentViewport.label === 'hd-desktop' ||
        this.$currentViewport.label === 'desktop-medium'
      ) {
        this.mobileMenuView = false;
      }
    }
  }
};
</script>
